\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}
\usepackage{amsmath}
\newcommand\emptyline{\vspace{12pt}}

\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\V{{\mathbb V}}
\def\I{{\mathbb I}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{\mbox{\sc lc}}
\def\lt{\mbox{\sc lt}}
\def\lp{\mbox{\sc lp}}
\def\gcd{\mbox{\sc gcd}}
\def\lcm{\mbox{\sc lcm}}
\def\red#1{\stackrel{#1}{\longrightarrow}}
\def\redplus#1{\stackrel{#1}{\longrightarrow}_+}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}{Corollary}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}{9}
\section{Hilbert's Nullstellensatz}


\subsection{The relation between ideals and varieties}

The dictionary of algebraic geometry provides a
way of translating between geometric and algebraic languages.  In particular, we
associated to any variety
$V$---the common zeroes in affine space of a set of polynomials $f_1,\dots,f_s$---an
ideal
$\I(V)$. On the other hand, we could simply use the polynomials directly to generate
an ideal $\<f_1,\dots,f_s\>$. In Lecture~2, we asked what the relation is between
these two ideals.  It is certainly clear that
$$
\<f_1,\dots,f_s\>\subseteq \I(V).
$$
on the other hand $\I(V)$ may be strictly larger than $\<f_1,\dots,f_s\>$ as may be
seen from some simple examples. The one we gave in Lecture~2 is:

{\bf Example 1.} $f=x^2+y^2\in\R[x,y]$. Here, $V=\{(0,0)\}\subseteq\R^2$.  Then
$\I(V)=\<x,y\>$, but clearly $x\notin\<f\>$. The problem here is that $\R$
is not algebraically closed.

{\bf Example 2.} Another, even simpler example is to consider $f=x^2\in k[x]$.
Clearly $x\in \I(V)$ whereas $x\notin\<x^2\>$.  Here it is the multiplicity of the
factor $x$ that is the problem. In some ways this is more fundamental.  At least we
can avoid the previous problem by working in the algebraic closure of $\R$.

The complete answer to our problem is provided by Hilbert's Nullstellensatz. First
we prove a simpler but fundamental result---the Weak Nullstellensatz.  The proof I
present (from Cox, Little and O'Shea) depends on the Extension Theorem from
Lecture~11.  That gave us circumstances under which we could be assured that a
partial solution in the variety determined by the first elimination ideal could be
extended to a full solution.

As a special case we note the following:

\begin{corollary}
\label{extcor}
Suppose $I=\<f_1,\dots,f_s\>\subset \kn$, with
$k$ algebraically closed, and let $I_1$ be the first elimination ideal of $I$. If
$f_1=cx_1^N+\mbox{terms in which $x_1$ has degree $<N$}$,
$c\neq0$, $N>0$ then the Extension Theorem holds for {\it all\/} partial solutions
in $\V(I_1)$.
\end{corollary}

\subsection{The Weak Nullstellensatz}



\begin{theorem}[The Weak Nullstellensatz]
Given an ideal $I\subseteq\kn$, $k$ algebraically closed, then  $\V(I)=\emptyset$ if and only if
$I=\kn$.
\end{theorem}

\begin{proof}
Put the other way about, the Theorem states that every proper ideal defines a
non-empty variety in the affine space over $k$. 

One direction of the proof is trivial. If $I$ is the whole polynomial ring then $1\in I$. For all $\ba\in\kn$, $1(\ba)=1\neq0$, therefore $\ba\notin \V(I)$. 

For the converse, suppose $\bV(I)=\emptyset$ and proceed by induction on the dimension $n$. For $n=1$, we know that every ideal $I\subset k[x]$ is generated by a single 
polynomial---$k[x]$ is a PID. Suppose $I=\<f\>$. If $f$ is non-constant then, since
$k$ is algebraically closed, $f$ has a zero which must necessarily lie in $\V(I)$.
Hence, given $\V(I)=\emptyset$ then $f$ must be a non-zero constant and so $1/f\in k$.
It follows that for any $g\in k[x]$, $g=\left(\frac1f g\right).f\in I$ and hence
$I= k[x]$.

Now suppose the theorem holds in $k[x_2,\dots,x_n]$ and $I=\<f_1,\dots,f_s\>\in\kn$.
If  $f_1$ is constant,  we are done, as in the $n=1$ case. So suppose $f_1$ has total degree $N>0$. For given $a_2,\dots, a_n\in k$, consider the non-singular linear coordinate change
\begin{eqnarray*}
x_1&=&x_1'\\
x_2&=&x_2'+a_2x_1'\\
\vdots\\
x_n&=&x_n'+a_nx_1'.
\end{eqnarray*}
In the new coordinates, the polynomial
\begin{eqnarray*}
f(x_1,\dots,x_n)&=&f(x_1',x_2'+a_2x_1',\dots,x_n'+a_nx_1')\\
&=&c(a_2,\dots,a_n){x_1'}^N+\mbox{terms in which $x_1'$ has degree $<N$}
\end{eqnarray*}
and $c\in k[x_2,\dots,x_n]$, $c\neq0$.  Since $k$ is algebraically closed it is infinite, hence there exist
$a_2,\dots,a_n$ such that $c(a_2,\dots,a_n)\neq0$. Fix such a choice and  for
any $f\in\kn$ rename it in the new coordinates as $f'$:
\[
f(x_1,\dots,x_n)=f'(x_1',\dots,x_n')
\]
In effect, the change of coordinates induces a ring homomorphism (in fact, an isomorphism) $\kn\to\kn$. Let $I'=\{f'\,:\,f\in I\}$, then $I'$ is an ideal and
$\V(I')=\emptyset\iff V(I)=\emptyset$. Thus we may assume, without loss of generality,
that $f_1=cx_1^N+\mbox{terms in which $x_1$ has degree $<N$}$ where $c\neq0$. 

Let $I_1$ be the first elimination ideal of $I$. Suppose $V(I_1)\neq\emptyset$, then
by Corollary~\ref{extcor}, $\V(I)\neq\emptyset$, a contradiction. Thus we may deduce that
$\V(I_1)=\emptyset$. By inductive hypothesis $I_1=k[x_2,\dots,x_n]$ and hence $1\in
I_1$. but
$I_1\subset I$ so $1\in I$ and the result follows.
\end{proof}

Note that the theorem gives us a condition for the {\it consistency\/} of a set of
polynomial equations: the equations $f_1=0,\dots,f_s=0$ have a solution if and only
if $I=\<f_1,\dots,f_s\>\neq\kn$ if and only if $1\notin I$. The last equivalence is
straightforward and is a very nice characterisation of consistency.  
Indeed it gives us a practical test for consistency.  For $1\in I$ if an only if
$1\in G$ for any minimal (or reduced) {\Gr} basis for $I$. This is clear, for if
$1\in I$ then for some $g_i\in G$, $\lt(g_i)|\lt(1)=1$, whence $g_i$ is constant as
$x^\ga>1$ for any $\ga\neq0$. But minimal {\Gr} bases consist of monic polynomials
so $g_i=1$.  Of course, if $G$ is reduced then in fact $G=\{1\}$.

\subsection{Radical Ideals}

The key to the relation between an ideal $I$ and the ideal $\I(\V(I))$ is illustrated
in the simple example~2 above. Whereas $I$ may contain some polynomial power $f^m$,
the ideal of the variety then contains $f$ itself.

\begin{definition}
An ideal is called {\bf radical} if whenever $f^m\in I$ for some $m\geq1$, then
$f\in I$.
\end{definition}

It is clear that for any variety $V$, the ideal $\I(V)$ is radical. 

\begin{definition}
Let $I\subset \kn$ be an ideal. Its {\bf radical}, $\sqrt I$, is the set
$$
\{f\,:\,f^m\in I\quad\mbox{for some}\quad m\geq1\}.
$$
\end{definition}

For example, suppose $I=\<(x+y)^2,(x-y)^3\>$. We can show (directly) that $x\in
\sqrt I$. For
\begin{eqnarray*}
x^4&=&\tfrac1{16}\left[(x+y)+(x-y)\right]^4\\
&=&\tfrac1{16}\left[(x+y)^4+4(x+y)^3(x-y)+6(x+y)^2(x-y)^2+
4(x+y)(x-y)^3+(x-y)^4\right]\\
&=&\tfrac1{16}\left[(x+y)^2+4(x+y)(x-y)+6(x-y)^2\right](x+y)^2+\tfrac1{16}\left[4(x+y)+(x-y)\right](x-y)^3.
\end{eqnarray*}
Thus $x^4\in I$ so $x\in\sqrt I$.

It is an easy exercise to prove that $\sqrt I$ is itself an ideal, and of course,
radical.  Moreover $\V(I)=\V(\sqrt I)$.

\begin{theorem}[Hilbert's or Strong Nullstellensatz]
Let $k$ be algebraically closed, then for any ideal $I\subset\kn$,
$$
\I(\V(I))=\sqrt I.
$$
\end{theorem}

\begin{proof}
By the Hilbert Basis Theorem, we may assume that $I=\<f_1,\dots,f_s\>$. We must show
that if $f\in \I(\V(I))$ then for some $m\geq1$, $f^m\in I$; that is to say
$f^m=\dsum_{i=1}^s q_if_i$ for some $q_i\in\kn$.

So, given $f\in \I(\V(I))$, consider the ideal $\tilde I=\<f_1,\dots,f_s,1-yf\>\subset
k[x_1,\dots, x_n,y]$. Suppose $(a_1,\dots,a_n,a_{n+1})\in k^{n+1}$. Then either
\begin{itemize}
\item
$(a_1,\dots,a_n)\in \V(I)$, then $f(a_1,\dots,a_n)=0$ and so
$$
(1-yf)(a_1,\dots,a_{n+1})=1-a_{n+1}f(a_1,\dots,a_n)=1
$$
as $f\in \I(\V(I))$, or
\item
$(a_1,\dots,a_n)\notin \V(I)$ and hence $f_i(a_1,\dots,a_n)\neq0$ for $i=1,\dots, s$.
\end{itemize}
In either case $(a_1,\dots,a_n,a_{n+1})\notin \V(\tilde I)$ so by the Weak
Nullstellensatz, $1\in\tilde I$.  That means
$$
1=\sum_{i=1}^sp_i(x_1,\dots,x_n,y)f_i+q(x_1,\dots,x_n,y)(1-yf).
$$
Now substitute $y=1/f(x_1,\dots,x_n)$ to get
$$
1=\sum_{i=1}^sp_i\left(x_1,\dots,x_n,\frac1f\right)f_i.
$$
The right hand side is a rational expression with some power of $f$ in the
denominator, say $f^m$. Multiplying through by $f^m$, we get
$$
f^m=\sum_{i=1}^sa_i(x_1,\dots,x_n)f_i\in I,
$$
as required.
\end{proof}


\end{document}
